<?php 
/**
 * @package Download Controller
 * @author Shaon
 * @version 1.0.5
 */
/*
Plugin Name: Download Controller  
Plugin URI: http://www.wpdownloadmanager.com/
Description: Manage, Track and Control all file downloads
Author: Shaon
Version: 1.0.5
Author URI: http://www.wpdownloadmanager.com/
*/
 

$d = str_replace('\\','/',dirname(__FILE__));
$d = explode("/", $d);
array_pop($d);
array_pop($d);
$d = implode('/', $d);

define('UPLOAD_DIR',$d.'/uploads/download-controller-files/');  
define('UPLOAD_BASE',$d.'/uploads/');  
if($_GET['wpdcact']=='process')
include("process.php");

include("download.php");
include("functions.php");
include("class.pagination.php");
include("wpdc-server-file-browser.php");
  
if(!$_POST)    $_SESSION['download'] = 0;

function wpdc_free_Install(){
    global $wpdb;
      /*if($wpdb->get_var("select count(*) from `{$wpdb->prefix}wpdc_files`")==0)
      $wpdb->query("drop table `{$wpdb->prefix}wpdc_files`");  */
      $sql = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}wpdc_files` (
              `id` int(11) NOT NULL AUTO_INCREMENT,
              `title` varchar(255) NOT NULL,
              `description` text NOT NULL,
              `category` text NOT NULL,
              `file` varchar(255) NOT NULL,
              `password` varchar(40) NOT NULL,
              `download_count` int(11) NOT NULL,
              `access` enum('guest','member') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
              `show_counter` tinyint(1) NOT NULL,
              `quota` INT NOT NULL,
              `link_label` varchar(255) NOT NULL,
              PRIMARY KEY (`id`)
            ) ENGINE=MyISAM  DEFAULT CHARSET=utf8";

      require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
      
      dbDelta($sql);
      dbDelta("ALTER TABLE `{$wpdb->prefix}wpdc_files` ADD `category` TEXT NOT NULL");
      
   update_option('wpdc_access_level','level_10');
   wpdc_create_dir();
      
}

function wpdc_new_packages($show=5, $show_count=true){
    global $wpdb;
     
    $data = $wpdb->get_results("select * from {$wpdb->prefix}wpdc_files order by id desc limit 0, $show",ARRAY_A);
    foreach($data as $d){
        
        $key = $d['id'];
        if($show_count) $sc = "<br/><i>$d[download_count] downloads</i>";         
        $url = home_url("/?download={$d[id]}");  
        echo "<li><a href='#' onclick='javascript:window.open(\"$url\",\"Window1\",\"menubar=no,width=400,height=200,toolbar=no, left=\"+((screen.width/2)-200)+\", top=\"+((screen.height/2)-100));return false;'>{$d[title]}</a> $sc</li>\r\n";
    }
}

   

function wpdc_downloadable($content){
    global $wpdb; 
    //$id = 2;
    preg_match_all("/\{filelink\=([^\}]+)\}/", $content, $matches);
    //
     
    
    $sap = count($_GET)>0?'&':'?';
    for($i=0;$i<count($matches[1]);$i++){
    $id = $matches[1][$i];    
    $data = $wpdb->query("select * from {$wpdb->prefix}wpdc_files were id='$id'",ARRAY_A);
    $wpdc_login_msg = get_option('wpdc_login_msg')?get_option('wpdc_login_msg'):'Login Required';
    $link_label = $data['link_label']?$data['link_label']:'Download';
    if($data['access']=='member'&&!is_user_logged_in())
    $matches[1][$i] = "<a href='".get_option('siteurl')."/wp-login.php?redirect_to=".$_SERVER['REQUEST_URI']."'  style=\"background:url('".get_option('siteurl')."/wp-content/plugins/download-manager/l24.png') no-repeat;padding:3px 12px 12px 28px;font:bold 10pt verdana;\">".$wpdc_login_msg."</a>";
    else {
    $matches[1][$i] = "<a class='wpdc-popup' href='{$_SERVER[REQUEST_URI]}{$sap}download={$id}' style=\"background:url('".get_option('siteurl')."/wp-content/plugins/download-manager/icon/download.png') no-repeat;padding:3px 12px 12px 28px;font:bold 10pt verdana;\">$link_label</a>";
    if($data['show_counter']!=0)
    $matches[1][$i] .= "<br><small style='margin-left:30px;'>Downloaded $data[download_count] times</small>";
    }
    }
    
    preg_match_all("/\{wpdm_category\=([^\}]+)\}/", $content, $cmatches);
    for($i=0;$i<count($cmatches[1]);$i++){         
    $cmatches[1][$i] = wpdc_embed_category($cmatches[1][$i]);
    }
    $content = str_replace($cmatches[0],$cmatches[1], $content);    
    return str_replace($matches[0],$matches[1], $content);    
    
}

function wpdc_cblist_categories($parent="", $level = 0, $sel = array()){
   $cats = maybe_unserialize(get_option('_fm_categories')); 
   if(is_array($cats)){
   if($parent!='') echo "<ul>";   
   foreach($cats as $id=>$cat){
       $pres = str_repeat("&mdash;", $level);
       if($cat['parent']==$parent){
       if(in_array($id,$sel))    
       $checked = 'checked=checked';
       else
       $checked = '';
       echo "<li><input type='checkbox' name='file[category][]' value='$id' $checked /> $cat[title]</li>\n";
       wpdc_cblist_categories($id,$level+1, $sel);}
   }
   if($parent!='') echo "</ul>";
   }
}

function wpdc_dropdown_categories($parent="", $level = 0){
   $cats = maybe_unserialize(get_option('_fm_categories')); 
   
   foreach($cats as $id=>$cat){
       $pres = str_repeat("&mdash;", $level);
       if($cat['parent']==$parent){       
       echo "<option value='$id' />{$pres} $cat[title]</option>\n";
       wpdc_dropdown_categories($id,$level+1, $sel);}
   }
   
} 

function wpdc_admin_options(){
    
    if(!file_exists(UPLOAD_DIR)&&$_GET[task]!='wpdc_create_dir'){
        
        echo "    
        <div id=\"warning\" class=\"error fade\"><p>
        Automatic dir creation failed! [ <a href='admin.php?page=wpdc&task=CreateDir&re=1'>Try again to create dir automatically</a> ]<br><br>
        Please create dir <strong>" . UPLOAD_DIR . "</strong> manualy and set permision to <strong>777</strong><br><br>
        Otherwise you will not be able to upload files.</p></div>";        
    }
    
    if($_GET[success]==1){
        echo "
        <div id=\"message\" class=\"updated fade\"><p>
        Congratulation! Plugin is ready to use now.
        </div>
        ";
    }
    
    
    if(!file_exists(UPLOAD_DIR.'.htaccess'))
    setHtaccess();
    
    if($_GET[task]!='')
    return call_user_func($_GET['task']);        
    else
    include('wpdc-list-files.php');
}

function wpdc_delete_file(){
    global $wpdb;
    if(is_array($_GET[id])){
        foreach($_GET[id] as $id){
            $qry[] = "id='".(int)$id."'";
        }
        $cond = implode(" and ", $qry);
    } else
    $cond = "id='".(int)$_GET[id]."'";
    $wpdb->query("delete from {$wpdb->prefix}wpdc_files where ". $cond);
    echo "<script>
        location.href='admin.php?page=wpdc';
        </script>";
    die();
}

function wpdc_create_dir(){
    if(!file_exists(UPLOAD_BASE)){
       @mkdir(UPLOAD_BASE,0777);       
   }
   @chmod(UPLOAD_BASE,0777);
   @mkdir(UPLOAD_DIR,0777);
   @chmod(UPLOAD_DIR,0777);
   wpdc_set_htaccess();
   if($_GET[re]==1) {
   if(file_exists(UPLOAD_DIR)) $s=1;
   else $s = 0;   
   echo "<script>
        location.href='{$_SERVER[HTTP_REFERER]}&success={$s}';
        </script>";
    die();
   }
}

function wpdc_settings(){
    if($_POST){
        update_option('wpdc_access_level',$_POST[access]);
        update_option('wpdc_login_msg',$_POST[wpdc_login_msg]);
    }
    if(is_uploaded_file($_FILES['icon']['tmp_name'])){
        ///print_r(dirname(__FILE__).'/icon/download.png');
        move_uploaded_file($_FILES['icon']['tmp_name'],dirname(__FILE__).'/icon/download.png');
    }
    $access = get_option('wpdc_access_level');
    include('wpdc-settings.php'); 
}

function wpdc_add_new_file(){
    global $wpdb; 
    if(!file_exists(UPLOAD_DIR)){
        
        echo "    
        <div id=\"warning\" class=\"error fade\"><p>
        Automatic dir creation failed! [ <a href='admin.php?page=wpdc&task=wpdc_create_dir&re=1'>Try again to create dir automatically</a> ]<br><br>
        Please create dir <strong>" . UPLOAD_DIR . "</strong> manualy and set permision to <strong>777</strong><br><br>
        Otherwise you will not be able to upload files.
        </p></div>";        
    }
    
    if($_GET[success]==1){
        echo "
        <div id=\"message\" class=\"updated fade\"><p>
        Congratulation! Plugin is ready to use now.
        </div>
        ";
    }
    
    if($_POST){
    
    if(is_uploaded_file($_FILES['media']['tmp_name'])){
        $info = pathinfo($_FILES['media']['name']);        
        //echo dirname(__FILE__).'/files/'.$_FILES['media']['name'];
        extract($_POST);
        $name = file_exists(dirname(__FILE__).'/files/'.$_FILES['media']['name'])?str_replace('.'.$info['extension'],'_'.uniqid().'.'.$info['extension'],$info['basename']):$_FILES['media']['name'];        
        move_uploaded_file($_FILES['media']['tmp_name'], UPLOAD_DIR . $name);
        $file['file'] = $name;
        
    }
    
        $file['show_counter'] = 0;
        $file['category'] = serialize($file['category']);
        $wpdb->insert("{$wpdb->prefix}wpdc_files", $file); 
        if(!$wpdb->insert_id){
            $wpdb->print_error();
            die();               
        }
        echo "<script>
        location.href='admin.php?page=wpdc';
        </script>";
    
   }

    
    include('wpdc-add-new-file.php');
}

function wpdc_edit_file(){
     global $wpdb;
    if($_POST){
    extract($_POST);
    if(is_uploaded_file($_FILES['media']['tmp_name'])){
        $info = pathinfo($_FILES['media']['name']);        
        //echo dirname(__FILE__).'/files/'.$_FILES['media']['name'];
    
        $name = file_exists(UPLOAD_DIR . $_FILES['media']['name'])?str_replace('.'.$info['extension'],'_'.uniqid().'.'.$info['extension'],$info['basename']):$_FILES['media']['name'];        
        move_uploaded_file($_FILES['media']['tmp_name'], UPLOAD_DIR . $name);        
        $file['file'] = $name;
    }        
         
        $file['category'] = serialize($file['category']);        
        $wpdb->update("{$wpdb->prefix}wpdc_files", $file, array("id"=>$_POST[id])); 
        
        echo "<script>
        location.href='admin.php?page=wpdc';
        </script>";
    
   }

    $file = $wpdb->get_row("select * from {$wpdb->prefix}wpdc_files where id='$_GET[id]'",ARRAY_A);    
    
    include('wpdc-add-new-file.php');
} 

function wpdc_categories(){
    
   if($_GET['task']=='DeleteCategory'){
        $tpldata = maybe_unserialize(get_option('_fm_categories'));
        unset($tpldata[$_GET['cid']]);         
        update_option('_fm_categories',@serialize($tpldata)); 
        echo "<script>
        location.href='{$_SERVER[HTTP_REFERER]}';
        </script>";
    die();
    } 
     if($_POST['cat']){
        $tpldata = maybe_unserialize(get_option('_fm_categories'));
        if(!is_array($tpldata)) $tpldata =array();
        $tcid = $_POST['cid']?$_POST['cid']:strtolower(preg_replace("/([^a-zA-Z0-9\-]+)/","-", $_POST['cat']['title']));
        $cid = $tcid;
        while(array_key_exists($cid, $tpldata)&&$_POST['cid']==''){
            $cid = $tcid."-".(++$postfx);
        }
        
        $tpldata[$cid] = $_POST['cat'];        
        update_option('_fm_categories',@serialize($tpldata));
         echo "<script>
        location.href='{$_SERVER[HTTP_REFERER]}';
        </script>";
        die();
    }
   include("wpdc-categories.php");
}

function wpdc_cat_dropdown_tree($parent="", $level = 0){
   $cats = maybe_unserialize(get_option('_fm_categories')); 
   foreach($cats as $id=>$cat){
       $pres = str_repeat("&mdash;", $level);
       if($cat['parent']==$parent){
       echo "<option value='$id'>{$pres} $cat[title]</option>\n";
       wpdc_cat_dropdown_tree($id,$level+1);}
   }
}

function wpdc_embed_category($id){
    global $wpdb, $current_user, $post, $wp_query;
    $postlink = get_permalink($post->ID);
    get_currentuserinfo();
    
    $user = new WP_User(null);
    $categories = maybe_unserialize(get_option("_fm_categories",true));
    $category = $categories[$id];
    $total = $wpdb->get_var("select count(*) from {$wpdb->prefix}wpdc_files where category like '%\"$id\"%'");
     
    $item_per_page =  10;
    $pages = ceil($total/$item_per_page);
    $page = $_GET['cp']?$_GET['cp']:1;
    $start = ($page-1)*$item_per_page;
    $pag = new Pagination();             
    $pag->items($total);
    $pag->limit($item_per_page);
    $pag->currentPage($page);
    $url = strpos($_SERVER['REQUEST_URI'],'?')?$_SERVER['REQUEST_URI'].'&':$_SERVER['REQUEST_URI'].'?';
    $pag->urlTemplate($url."cp=[%PAGENO%]");

    $ndata = $wpdb->get_results("select * from {$wpdb->prefix}wpdc_files where category like '%\"$id\"%' limit $start, $item_per_page",ARRAY_A);
     

$sap = count($_GET)>0?'&':'?';
$html = '';
foreach($ndata as $data){
  
    $link_label = $data['title']?$data['title']:'Download';  
    $data['page_link'] = "<a class='wpdc-popup' style=\"background:url('".get_option('siteurl')."/wp-content/plugins/download-manager/icon/download.png') no-repeat;padding:3px 12px 12px 28px;font:bold 10pt verdana;\" href='{$postlink}{$sap}download={$data[id]}'>$link_label</a>";
    if($data[preview]!='')
    $data['thumb'] = "<img class='wpdm_icon' align='left' src='".plugins_url()."/{$data[preview]}' />";
    else
    $data['thumb'] = '';
    if($data[icon]!='')
    $data['icon'] = "<img class='wpdm_icon' align='left' src='".plugins_url()."/{$data[icon]}' />";
    else
    $data['icon'] = '';
    
    
            if($data['show_counter']==1){
                $counter = "{$data[download_count]} downloads<br/>";
                $data['counter'] = $counter;
            }
            
            //foreach( $data as $ind=>$val ) $reps["[".$ind."]"] = $val;
            //$repeater =  stripslashes( strtr( $category['template_repeater'],   $reps ));  
            $template = "<li><b>$data[page_link]</b><br/>$data[counter]</li>";
            
            $html .= $template;
          
            
END;
            
        
        
   
        
 
        
}
 

return "<ul class='wpdc-category $id'>".$html."</div><div style='clear:both'></ul>";
}

 

function wpdc_tinymce()
{
  wp_enqueue_script('common');
  wp_enqueue_script('jquery-color');
  wp_admin_css('thickbox');
  wp_print_scripts('post');
  wp_print_scripts('media-upload');
  wp_print_scripts('jquery');
  wp_print_scripts('jquery-ui-core');
  wp_print_scripts('jquery-ui-tabs');
  wp_print_scripts('tiny_mce');
  wp_print_scripts('editor');
  wp_print_scripts('editor-functions');
  add_thickbox();
  wp_tiny_mce();
  wp_admin_css();
  wp_enqueue_script('utils');
  do_action("admin_print_styles-post-php");
  do_action('admin_print_styles');
  remove_all_filters('mce_external_plugins');
}

function wpdc_set_htaccess(){    
    $cont = 'RewriteEngine On
    <Files *>
    Deny from all
    </Files> 
       ';
       @file_put_contents(UPLOAD_DIR.'.htaccess',$cont);
}


function wpdc_front_js(){
    ?>
    <script language="JavaScript">
    <!--
      jQuery(function(){
          jQuery('.wpdc-popup').colorbox();
      })
    //-->
    </script>
    <?php
}

function wpdc_copyold(){
    global $wpdb;
    $ids = get_option('wpdcc2p_ids',true);
    if($_POST['task']=='wpdc_copy_files'){        
        if(!is_array($ids)) $ids = array();
        if(!is_array($_POST[id])) $_POST[id] = array();
        foreach($_POST[id] as $fid){
            //if(!in_array($fid, $ids)){
            $file = $wpdb->get_row("select * from ahm_files where id='$fid'", ARRAY_A);                        
            unset($file[id]);
            //print_r($file);
            //$wpdb->show_errors();
            $wpdb->insert("{$wpdb->prefix}wpdc_files",$file);
            //$wpdb->print_error();die() ;
            //}
        }
        if(is_array($ids))
        $ids = array_unique(array_merge($ids, $_POST['id']));
        else
        $ids = $_POST['id'];
        /*foreach($_POST as $optn=>$optv){
            update_option($optn, $optv);
        }                                      */
       
        update_option('wpdcc2p_ids',$ids);
        die('Copied successfully');
    }
  
    $res = mysql_query("select * from ahm_files");
    
    ?>

 
<div class="wrap">
    <div class="icon32" id="icon-upload"><br></div>
    
<h2>Copy from Download Manager</h2>  <br>

<div class="clear"></div>
<form action="" method="post">
<input type="hidden" name="task" value="wpdc_copy_files" />

<table cellspacing="0" class="widefat fixed">
    <thead>
    <tr>
    <th style="" class="manage-column column-cb check-column" id="cb" scope="col"><input class="call m" type="checkbox"></th>    
    <th style="" class="manage-column column-media" id="media" scope="col">File</th>    
    <th style="" class="manage-column column-parent" id="parent" scope="col">Copied</th>
    </tr>
    </thead>

    <tfoot>
    <tr>
    <th style="" class="manage-column column-cb check-column" id="cb" scope="col"><input class="call m" type="checkbox"></th>    
    <th style="" class="manage-column column-media" id="media" scope="col">File</th>
    <th style="" class="manage-column column-parent" id="parent" scope="col">Copied</th>
    </tr>
    </tfoot>

    <tbody class="list:post" id="the-list">
    <?php while($media = mysql_fetch_assoc($res)) {   $media['copied'] = @in_array($media[id],$ids)?'Yes':'No'; ?>
    <tr valign="top" class="alternate author-self status-inherit" id="post-8">

                <th class="check-column" scope="row"><input type="checkbox" value="<?php echo $media[id];?>" class="m" name="id[]"></th>
                
                <td class="media column-media">
                    <strong><a title="Edit" href="admin.php?page=file-manager&task=EditFile&id=<?php echo $media['id']?>"><?php echo $media['title']?></a></strong>                     
                </td>
                <td class="parent column-parent"><b><?php echo $media['copied']; ?></b></td>
     
     </tr>
     <?php } ?>
    </tbody>
</table>
                     <br>
                     
<input type="submit" value="Copy Selected Files" class="button-primary">
</form>
 <script language="JavaScript">
 <!--
   jQuery('.call').click(function(){
       if(this.checked)
       jQuery('.m').attr('checked','checked');
       else
       jQuery('.m').removeAttr('checked');
   });
 //-->
 </script>
    </div>
    <?php
}

function wpdc_menu(){
    add_menu_page("Download Controller","Download Controller",get_option('wpdc_access_level'),'wpdc','wpdc_admin_options');
    add_submenu_page( 'wpdc', 'Download Controller', 'Manage', get_option('wpdc_access_level'), 'wpdc', 'wpdc_admin_options');    
    add_submenu_page( 'wpdc', 'Add New File &lsaquo; Download Controller', 'Add New File', get_option('wpdc_access_level'), 'wpdc/add-new-file', 'wpdc_add_new_file');    
    add_submenu_page( 'wpdc', 'Categories &lsaquo; Download Controller', 'Categories', 'administrator', 'wpdc/categories', 'wpdc_categories');    
    add_submenu_page( 'wpdc', 'Copy &lsaquo; Download Controller', 'Copy Old Version Files', 'administrator', 'wpdc/copy', 'wpdc_copyold');    
    add_submenu_page( 'wpdc', 'Settings &lsaquo; Download Controller', 'Settings', 'administrator', 'wpdc/settings', 'wpdc_settings');    
    
}

if(is_admin()){
    add_action("admin_menu","wpdc_menu");
    include("wpdc-free-mce-button.php");
    wp_enqueue_style('icons',plugins_url().'/download-controler/css/icons.css');     
}else{
    wp_enqueue_script('jquery');  
   wp_enqueue_script('11',plugins_url().'/download-controler/js/jquery.colorbox-min.js');         
   wp_enqueue_style('22',plugins_url().'/download-controler/css/colorbox.css');      
   add_action('wp_head','wpdc_front_js');
}

if($_GET['page']=='wpdc/add-new-file'||$_GET['page']=='wpdc'||$_GET['page']=='wpdc/templates')
add_filter('admin_head','wpdc_tinymce');



add_filter( 'the_content', 'wpdc_downloadable');

include("wpdc-widgets.php");

register_activation_hook(__FILE__,'wpdc_free_Install');
