 
(function() {

    tinymce.create('tinymce.plugins.wpdc_tinyplugin', {

        init : function(ed, url){            
            ed.addCommand('wpdc_mcedonwloadmanager', function() {
                                ed.windowManager.open({
                                        title: 'Download Controller',
                                        file : 'admin.php?wpdc_action=wpdc_tinymce_button',
                                        height: 300,
                                        width:400,                                        
                                        inline : 1
                                }, {
                                        plugin_url : url, // Plugin absolute URL
                                        some_custom_arg : 'custom arg' // Custom argument
                                });
                        });
            
            ed.addButton('wpdc_tinyplugin', {
                title : 'Download Manager: Insert Package or Category',
                cmd : 'wpdc_mcedonwloadmanager',
                image: url + "/img/donwloadmanager.png"
            });
        },

        getInfo : function() {
            return {
                longname : 'WPDC - TinyMCE Button Add-on',
                author : 'Shaon',
                authorurl : 'http://www.wpdownloadmanager.com',
                infourl : 'http://www.wpdownloadmanager.com',
                version : "1.0"
            };
        }
    });

    tinymce.PluginManager.add('wpdc_tinyplugin', tinymce.plugins.wpdc_tinyplugin);
    
})();
